SystemOrganization addCategory: #LandSlide!

TestCase subclass: #LandSlideTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

Object subclass: #ClassDocumentation
	instanceVariableNames: 'name superClassName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!ClassDocumentation class methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:46'!
name: aString superClassName: anotherString
	^ ((self new) name: aString) superClassName: anotherString! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 15:17'!
name
	^ name! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 15:17'!
name: aString
	name := aString! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 17:00'!
printOn: aStream
	aStream nextPutAll: 'a ClassDocumentation(Name: '.
	aStream nextPutAll: name.
	aStream nextPutAll: ', Superclass: '.
	aStream nextPutAll: superClassName.
	aStream nextPutAll: ')'! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 15:17'!
superClassName
	^ superClassName! !

!ClassDocumentation methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 15:17'!
superClassName: aString
	superClassName := aString! !

Object subclass: #LandSlideParser
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:56'!
gatherClasses: declarations
	| nodes doits classes |
	nodes := declarations 
		select: [ :decl | decl isKindOf: DoItDeclaration ]
		thenCollect: [ :decl | parser parse: (decl contents readStream) class: UndefinedObject noPattern: true context: nil notifying: nil ifFail: [  ] ].
	doits := nodes 
		select: [ :node | node selector == #DoIt ]
		thenCollect: [ :node | ((node block) statements at: 1) expr ].
	classes := doits
		select: [ :expr | expr isKindOf: MessageNode ]
		thenCollect: [ :expr | ClassDocumentation name: (((expr arguments at: 1) key) asString) superClassName: (expr receiver name) ].
	^ classes! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:20'!
gatherMethods: declarations
	^ declarations 
			select: [ :decl | decl isKindOf: MethodDeclaration ]
			thenCollect: [ :decl | parser parse: (decl contents) class: UndefinedObject  ].! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:21'!
initialize
	parser := Parser new! !

!LandSlideParser methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 16:22'!
parseString: aString 
	| cffp declarations methods classes |
	"Parses a given file written in ChunkFileFormat, returning an object
	which represents the materials necessary for generating documentation"
	cffp := ChunkFileFormatParser for: (ReadStream on: aString).
	declarations := cffp parseDeclarations.
	methods := self gatherMethods: declarations.
	classes := self gatherClasses: declarations.
	^ (DocumentationHolder withClasses: classes andMethods: methods) decls: declarations.! !

Object subclass: #MonticelloUnpacker
	instanceVariableNames: 'filename'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!MonticelloUnpacker class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:44'!
fromUrl: url
	"Passing a string url to a monticello project online this will download that 
	file and get the contents of the snapshot.st file and also will cleanup after 
	itself with all temporary files"
	| dir znurl filename unpacker stringContents |
	dir := FileSystem disk workingDirectory .
	ZnClient new
		url: url;
		downloadTo:dir . 
	znurl := ZnUrl fromString: url .
	filename := znurl lastPathSegment .
	unpacker := (MonticelloUnpacker new)
		filename: (dir / filename) .
	stringContents := unpacker extractStringFromFile .
	unpacker cleanupFile .
	^stringContents! !

!MonticelloUnpacker class methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:43'!
getNewFileContents
	"This will open a filepicker where the user can select a .mcz file and our unpacker
	will take that file and get the contents of the snapshot.st file and also will cleanup after 
	itself with all temporary files"
	| file unpacker |
	file := StandardWindow new fileOpen: '' .
	unpacker := (MonticelloUnpacker new)  
		filename: file .
	^ unpacker extractStringFromFile ! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:33'!
cleanupFile
	self filename deleteAll! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:42'!
extractStringFromFile
	"This will actually take the filename used for this unpacker and extract it 
	and return the contents of snapshot.st"
	| fulldir dir zip fileStream fileContents|
	fulldir := self filename .
	zip := ZipArchive new readFrom: (fulldir fullName) .
	dir := FileSystem disk workingDirectory / 'temp'.
	dir createDirectory .
	zip extractAllTo:  dir .
	fileStream := (dir / 'snapshot' / 'source.st') readStream .
	fileContents := fileStream contents .
	dir deleteAll .
	^fileContents! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:20'!
filename
	"comment stating purpose of message"
	^ filename! !

!MonticelloUnpacker methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/2/2013 12:20'!
filename: aFileName
	"comment stating purpose of message"
	filename := aFileName! !

WAComponent subclass: #DocumentationHolder
	instanceVariableNames: 'classes methods decls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!DocumentationHolder class methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
withClasses: classes andMethods: methods
	^ (self new classes: classes) methods: methods! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/5/2013 15:50'!
classes
	^classes! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
classes: theClasses
	classes := theClasses! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 5/2/2013 14:39'!
decls
	^ decls! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 17:09'!
decls: theDecls
	decls := theDecls! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/5/2013 15:48'!
methods
	^methods! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'ChaseGeigle 4/17/2013 16:47'!
methods: theMethods
	methods := theMethods! !

!DocumentationHolder methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/6/2013 09:36'!
renderContentOn: html
	"html heading: 'Classes'.
	self classes  do: [ :v |  
		html paragraph: (v name).
		html break].
	html heading: 'Methods'.
	self methods  do: [ :v |  
		"" copyWithRegex: (String cr) matchesReplacedWith: '<br />' ""
		html paragraph: (v selector).
		html paragraph: (v sourceText) .
		html break .
	]."
html div
      script: html jQuery new accordion;
      with: [
         self classes do: [ :name  |
            html div: [ html anchor: (name name) ].
            html div: [self methods  do: [ :v |  
		" copyWithRegex: (String cr) matchesReplacedWith: '<br />' "
		html paragraph: (v selector).
		html paragraph: (v sourceText) .
		html break .
	]. ] ] ]! !

WAComponent subclass: #LandSlidePage
	instanceVariableNames: 'counter url classes methods decls holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LandSlide'!

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/6/2013 09:57'!
buildDocumentation
	| string pars |
	string := MonticelloUnpacker fromUrl: (self url) .
	pars := LandSlideParser  new .
	holder := pars parseString: string.
	! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/5/2013 15:26'!
initialize
	super initialize.
	counter := WACounter new .! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/6/2013 10:30'!
renderContentOn: html
	html heading: 'Lanslide'.
 	html form: [
        html text: 'MCZ URL: '.
        html textInput
            callback: [ :value | self url: value ];
		value: (self url);
		size: 100.
        html break.
        html submitButton
            callback: [ self buildDocumentation ];
            value: 'Build Documentation'].
	holder ifNotNil: [  
		html div
			class: 'component';
			with: holder.
	]! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/6/2013 09:55'!
style
^ 'body { 
    font: 10pt Arial, Helvetica, sans-serif, Times New Roman; 
} 
h2 { 
    font-size: 12pt; 
    font-weight: normal; 
    font-style: italic; 
} 
table { border-collapse: collapse; } 
td { 
    border: 2px solid #CCCCCC; 
    padding: 4px; 
} 
#author { 
    border: 1px solid black; 
    padding: 2px; 
    margin: 2px; 
} 
.subcomponent { 
    border: 2px solid lightblue; 
    padding: 2px; 
    margin: 2px; 
} 
.highlight { background-color: yellow; } 
.boolean { background-color: lightgrey; } 
.field { background-color: lightgrey; } 
'! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/6/2013 09:34'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
    anHtmlRoot stylesheet url: 'http://seaside.st/styles/main.css' .
	anHtmlRoot stylesheet url: 'http://code.jquery.com/ui/1.10.3/themes/smoothness/jquery-ui.css'! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/5/2013 15:06'!
url
	^url! !

!LandSlidePage methodsFor: 'as yet unclassified' stamp: 'SeanHurley 5/5/2013 15:07'!
url: newUrl
	url := newUrl! !
